<?php

namespace Wp618\WpformsSender;

if ( !defined( 'ABSPATH' ) ) exit;

//
class Commentmeta_model extends Model
{
    protected $table = 'commentmeta';
    protected $is_dev_table = false;

    const HOT_POST_COMMENT_ID = 2000000000;
    const HOT_POST_META_KEY = 'hot_post';
    const HOT_POST_MAX_COUNT = 1000;

    const LIKE_POST_COMMENT_ID = 2000000000;
    const LIKE_POST_META_KEY = 'top_like';
    const LIKE_POST_MAX_COUNT = 1000;

    //
    public function set_like($post_id, $like){
        return $this->set_rank($post_id, $like, self::LIKE_POST_COMMENT_ID,
            self::LIKE_POST_META_KEY,self::LIKE_POST_MAX_COUNT);
    }

    //
    public function set_hot($post_id, $pv){
        return $this->set_rank($post_id, $pv, self::HOT_POST_COMMENT_ID,
            self::HOT_POST_META_KEY,self::HOT_POST_MAX_COUNT);
    }

    //
    private function set_rank($post_id, $num, $comment_id, $meta_key, $max_count){
        $num = (int) $num;

        $value = get_comment_meta($comment_id, $meta_key, true );
        $data = json_decode($value, true) ? : [];

        if(!empty($data) && count($data) > $max_count){
            $min = min($data);
            if($min > $num){
                return false;
            }

            $key = array_search($min, $data);
            if($key !== false){
                unset($data[$key]);
            }
        }

        $data[$post_id] = $num;
        $new_value = json_encode($data);

        return update_comment_meta($comment_id, $meta_key, $new_value);
    }

    //
    public function get_hot_post_id_list(){
        return $this->get_rand_list(self::HOT_POST_COMMENT_ID, self::HOT_POST_META_KEY);
    }

    //
    public function get_like_post_id_list(){
        return $this->get_rand_list(self::LIKE_POST_COMMENT_ID, self::LIKE_POST_META_KEY);
    }

    //
    private function get_rand_list($comment_id, $meta_key){
        $value = get_comment_meta($comment_id, $meta_key, true );
        $data = json_decode($value, true) ? : [];

        return $data;
    }

}