<?php

namespace Wp618\WpformsSender;

if ( !defined( 'ABSPATH' ) ) exit;

//
class AppSet
{
    //
    private $app;

    //
    public function __construct(){
        $this->app = App::getInstance();

        $this->reg_menu();

        add_action( 'admin_menu', [$this, 'hide_back_posts_menu']);

        //
        if(Constant::ADMIN_FOOTER_ICON){
            $ns = str_replace('\\', '_', __NAMESPACE__);
            if(isset($_SERVER['REQUEST_URI']) && stripos($_SERVER['REQUEST_URI'], $ns) !== false){
                add_action('admin_footer_text', function($text){
                    $q = [
                        'name' => $this->app->get_app_item('app_name'),
                        'ver' => $this->app->get_app_item('app_version'),
                        'ext' => '.png',
                    ];

                    $url = 'https://wp618.com/wp-json/plugin-auth/v1/png?' . http_build_query($q);
                    $img = '<img src="' . $url . '" height="16" style="vertical-align: middle;">';
                    $copy = '<a href="https://wp618.com" target="_blank">https://wp618.com</a>';

                    return $text . $img .' 更多插件: ' . $copy;
                });
            }
        }

        // hide post-type permalink
        if(Constant::REMOVE_PERMALINK_POST_TYPE_lIST){
            // post list
            add_filter('post_row_actions', function ($actions, $post){
                if(!empty($post) && in_array($post->post_type, Constant::REMOVE_PERMALINK_POST_TYPE_lIST)){
                    unset($actions['view']);
                }

                return $actions;
            }, 10, 2);

            // post edit
            add_filter( 'get_sample_permalink_html', [$this, 'remove_permalink_meta_box'], 10, 5);
        }
    }

    //
    private function reg_menu(){
        foreach (Constant::REG_MENU_LIST as $key => $val){
            register_nav_menus([
                $key => __($val)
            ]);
        }
    }

    // 移除 admin menu 链接
    public function hide_back_posts_menu() {
        foreach (Constant::ADMIN_MENU_HIDE_LIST as $name){
            remove_menu_page($name);
        }
    }

    // 移除编辑页面不需要的固定链接
    public function remove_permalink_meta_box($return, $ID, $new_title, $new_slug, $post) {
        $post_type = '';

        if(isset($_GET['post_type'])){
            $post_type = $_GET['post_type'];
        }else{
            if(!empty($post)){
                $post_type = $post->post_type;
            }
        }

        if(!empty($post_type) && in_array($post_type, Constant::REMOVE_PERMALINK_POST_TYPE_lIST)){
            return '';
        }

        return $return;
    }


}